/***************************************************************************
                           sound.c  -  description
                             -------------------
   No real code here. This file is here so I don't have to include
   non-portable files in the Makefile.
                             -------------------
    begin                : Wed May 11 2005
    copyright            : (C) 2005 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
 
#include "sound.h"

#if defined(__OSS_SOUND__)

# include "oss/oss_sound.c"

#elif defined(__ALSA_SOUND__)

# include "alsa/alsa_sound.c"

#elif defined(__DIRECTSOUND_SOUND__)

# include "DirectSound/DirectSound_sound.c"

#else

# error "PLEASE CHOOSE A SOUND_MODULE"

#endif

#ifndef _NO_51_SURROUND_
static u32 sur51_order = SUR51_ORDER_DEFAULT;

/* Sets the order of the 5.1 surround channels to one of the 
    SUR51_ORDER_* values. */
void SOUND_51_SURROUND_set_order(u32 order)
{
   if (order <= SUR51_ORDER_FLFT_FRGT_RLFT_RRGT_FCEN_LFE)
      sur51_order = order;
}

/* Returns the position of the requested channel. */
u32 SOUND_51_SURROUND_get_pos(u32 channel)
{
   if (channel <= SUR51_CH_LFE) {   
      if (sur51_order == SUR51_ORDER_FLFT_FRGT_FCEN_LFE_RLFT_RRGT) {
         if (channel == SUR51_CH_FRGT)
            channel = 1;
         else if (channel == SUR51_CH_FCEN)
            channel = 2;
         else if (channel == SUR51_CH_LFE)
            channel = 3;
         else if (channel == SUR51_CH_RLFT)
            channel = 4;
         else if (channel == SUR51_CH_RRGT)
            channel = 5;
      }
      else if (sur51_order == SUR51_ORDER_FLFT_FRGT_RLFT_RRGT_FCEN_LFE) {
         if (channel == SUR51_CH_FRGT)
            channel = 1;
         else if (channel == SUR51_CH_RLFT)
            channel = 2;
         else if (channel == SUR51_CH_RRGT)
            channel = 3;
         else if (channel == SUR51_CH_FCEN)
            channel = 4;
      }
   }
   else
      channel = 0;
   return channel;
}
#endif

