/***************************************************************************
                         SEQ_LAYER.h  -  description
                             -------------------
   Stuff needed for handling the VC1 sequence layer.
                             -------------------
    begin                : Tue May 23 2006
    copyright            : (C) 2006 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __SEQ_LAYER_H__
#define __SEQ_LAYER_H__

#include "common/typedefs.h"


#define VC1_SEQ_PROFILEp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->profile & 0xC0)
#define VC1_SEQ_PROFILEs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.profile  & 0xC0)
#define VC1_PROFILE_SIMPLE    0x00
#define VC1_PROFILE_MAIN      0x40
#define VC1_PROFILE_RESERVED  0x80
#define VC1_PROFILE_ADVANCED  0xC0

#define VC1_SEQ_LEVELp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->profile & 0x38)
#define VC1_SEQ_LEVELs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.profile  & 0x38)

#define VC1_SEQ_COLOUR_FORMATp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->profile & 0x06)
#define VC1_SEQ_COLOUR_FORMATs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.profile  & 0x06)
#define VC1_COLOUR_FORMAT_420 0x02


#define VC1_SEQ_FRAMERATE_PPp(ptr_to_SEQ_LAYER) \
   (((ptr_to_SEQ_LAYER->postproc >> 3) & 0x1C) + 0x02)
#define VC1_SEQ_FRAMERATE_PPs(struct_SEQ_LAYER) \
   (((struct_SEQ_LAYER.postproc  >> 3) & 0x1C) + 0x02)

#define VC1_SEQ_BITRATE_PPp(ptr_to_SEQ_LAYER) \
   (((ptr_to_SEQ_LAYER->postproc << 3) & 0xF8) + 0x04)
#define VC1_SEQ_BITRATE_PPs(struct_SEQ_LAYER) \
   (((struct_SEQ_LAYER.postproc  << 3) & 0xF8) + 0x04)


#define VC1_SEQ_PP_FLAGp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->flags & 0x80)
#define VC1_SEQ_PP_FLAGs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.flags  & 0x80)

#define VC1_SEQ_PULLDOWNp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->flags & 0x40)
#define VC1_SEQ_PULLDOWNs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.flags  & 0x40)

#define VC1_SEQ_INTERLACEp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->flags & 0x20)
#define VC1_SEQ_INTERLACEs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.flags  & 0x20)

#define VC1_SEQ_FRAMECNT_FLAGp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->flags & 0x10)
#define VC1_SEQ_FRAMECNT_FLAGs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.flags  & 0x10)

#define VC1_SEQ_FRAMEINTERP_FLAGp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->flags & 0x08)
#define VC1_SEQ_FRAMEINTERP_FLAGs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.flags  & 0x08)

#define VC1_SEQ_PSFp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->flags & 0x02)
#define VC1_SEQ_PSFs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.flags  & 0x02)


#define VC1_EPT_BROKENp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_flags & 0x80)
#define VC1_EPT_BROKENs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_flags  & 0x80)

#define VC1_EPT_CLOSEDp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_flags & 0x40)
#define VC1_EPT_CLOSEDs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_flags  & 0x40)

#define VC1_EPT_PANSCANp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_flags & 0x20)
#define VC1_EPT_PANSCANs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_flags  & 0x20)

#define VC1_EPT_REFDISTp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_flags & 0x10)
#define VC1_EPT_REFDISTs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_flags  & 0x10)

#define VC1_EPT_LOOPFILTERp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_flags & 0x08)
#define VC1_EPT_LOOPFILTERs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_flags  & 0x08)

#define VC1_EPT_FASTUV_MCp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_flags & 0x04)
#define VC1_EPT_FASTUV_MCs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_flags  & 0x04)

#define VC1_EPT_EXT_MVp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_flags & 0x02)
#define VC1_EPT_EXT_MVs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_flags  & 0x02)

#define VC1_EPT_EXT_DMVp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_flags & 0x01)
#define VC1_EPT_EXT_DMVs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_flags  & 0x01)


#define VC1_EPT_DQUANTp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_quant & 0xC0)
#define VC1_EPT_DQUANTs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_quant  & 0xC0)

#define VC1_EPT_VSTRANSFORMp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_quant & 0x20)
#define VC1_EPT_VSTRANSFORMs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_quant  & 0x20)

#define VC1_EPT_QUANTIZERp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_quant & 0x18)
#define VC1_EPT_QUANTIZERs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_quant  & 0x18)


#define VC1_EPT_RANGEMAP_Y_FLAGp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_rangemap & 0x80)
#define VC1_EPT_RANGEMAP_Y_FLAGs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_rangemap  & 0x80)

#define VC1_EPT_RANGEMAP_Yp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_rangemap & 0x70)
#define VC1_EPT_RANGEMAP_Ys(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_rangemap  & 0x70)

#define VC1_EPT_RANGEMAP_UV_FLAGp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_rangemap & 0x08)
#define VC1_EPT_RANGEMAP_UV_FLAGs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_rangemap  & 0x08)

#define VC1_EPT_RANGEMAP_UVp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_rangemap & 0x07)
#define VC1_EPT_RANGEMAP_UVs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_rangemap  & 0x07)


#define VC1_SEQ_MULTIRESp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->flags & 0x01)
#define VC1_SEQ_MULTIRESs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.flags  & 0x01)

#define VC1_SEQ_OVERLAPp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_quant & 0x04)
#define VC1_SEQ_OVERLAPs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_quant  & 0x04)

#define VC1_SEQ_SYNC_MARKERSp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_quant & 0x02)
#define VC1_SEQ_SYNC_MARKERSs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_quant  & 0x02)

#define VC1_SEQ_RANGE_REDp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->entrypt_quant & 0x01)
#define VC1_SEQ_RANGE_REDs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.entrypt_quant  & 0x01)

#define VC1_SEQ_MAXBFRAMESp(ptr_to_SEQ_LAYER) \
   (ptr_to_SEQ_LAYER->profile & 0x01)
#define VC1_SEQ_MAXBFRAMESs(struct_SEQ_LAYER) \
   (struct_SEQ_LAYER.profile  & 0x01)


#define VC1_VIDEO_STATE_MASK                 0xFF000000
#define VC1_VIDEO_read_SEQ_LAYER_STATE       0x00000000
#define VC1_VIDEO_read_ENTRYPT_LAYER_STATE   0x01000000
#define VC1_VIDEO_read_PIC_LAYER1_STATE      0x02000000
#define VC1_VIDEO_read_PIC_LAYER2_STATE      0x03000000
#define VC1_VIDEO_read_I_MACROBLOCK_STATE    0x10000000
#define VC1_VIDEO_read_P_MACROBLOCK_STATE    0x20000000
#define VC1_VIDEO_read_B_MACROBLOCK_STATE    0x40000000
#define VC1_VIDEO_read_BI_MACROBLOCK_STATE   0x50000000
#define VC1_VIDEO_frame_completed_STATE      0xFFFFFFFF

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
   const
   u8 *payload;
   u32 payload_len,        /* Number of bytes in the payload */
       state;
   u8  bit_shift, data,
       profile,
/*
      2   Profile  <0-2> Reserved
                   <3>   Advanced
      3   Level    <0-4> Level number
                   <5-7> Reserved
      2   ColourDiff_Format            Color format used in each picture.
                   <0>   Reserved
                   <1>   4:2:0
                   <2-3> Reserved
     *1   MaxBFrames
*/
       postproc,
/*
      3   FrmRtQ_PP
      5   BitRtQ_PP
*/
       flags,
/*
      1   PP_Flag
      1   Pulldown                     Pulldowm info can be found in the 
                                        picture headers.
      1   Interlace                    Interlaced pictures may be found in the
                                        sequence.
      1   FrameCnt_Flag                Frame count can be found in the picture
                                        headers.
      1   FrameInterp_Flag             Frame interpolation info can be found in
                                        the picture headers.
      1   Reserved
      1   PSF                          Progressive Segmented Frame. Set when
                                        the field pictures come from the same
                                        frame (not true interlaced content).
     *1   MultiRes
*/
       entrypt_flags,
/*
      1   BrokenLink
      1   ClosedEntry
      1   PanScan
      1   RefDist
      1   LoopFilter
      1   FastUV_MC
      1   Ext_MV
      1   Ext_DMV
*/
       entrypt_quant,
/*
      2   DQuant
      1   VSTransform
      2   Quantizer
     *1   Overlap
     *1   SyncMarkers
     *1   RangeRed
*/
       entrypt_rangemap;
/*
      1   RangeMapY_Flag
      3   RangeMapY
      1   RangeMapUV_Flag
      3   RangeMapUV
*/
   u16 wid, hgt,
       disp_wid, disp_hgt,
       framerate_num, framerate_den,
       BPstate, BPcnt, BPpos, BPcnt2;
} SEQ_LAYER;

/* Read the SEQ_STRUCT data.
      INPUT: seq - Pointer to a SEQ_LAYER structure. */
void VC1_VIDEO_read_SEQ_STRUCT(SEQ_LAYER *seq);

#ifdef __cplusplus
};
#endif

#endif
